<script lang="ts">
  import { Gql } from '@db';
  import { onMount } from 'svelte';
  import { EventRole } from '@auth/models';
  import LabeledContainer from '@components/LabeledContainer.svelte';
  import Prism from '@components/Utils/Prism.svelte';
  import { Badge, Input } from '@sveltestrap/sveltestrap';

  export let checkName: string;
  export let teamName: string;
  let resultCodes: string[] = [];
  let possibleResultCodes: string[] = [];
  let checkResultList: CheckResultListItem[] = [];
  let selectedId: string | null = null;
  let followLatest = true;

  $: console.log(checkName, teamName, possibleResultCodes);

  const resultCodeQuery = `query GetCheckResultList {
    checks_results_aggregate(limit: 1000, distinct_on: result_code) {
      nodes {
        result_code
      }
    }
  }`;

  type ResultCodeQueryResponse = {
    checks_results_aggregate: {
      nodes: [
        {
          result_code: string;
        },
      ];
    };
  };

  type CheckResultListItem = {
    id: string;
    check_time: string;
    result_code: string;
    participant: string;
    staff: string;
  };

  async function getPossibleResultCodes() {
    const response = await Gql.query<ResultCodeQueryResponse>(resultCodeQuery);
    return response?.checks_results_aggregate.nodes.map((node) => node.result_code);
  }

  const listQuery = `subscription GetCheckResultList($checkName: String!, $teamName: String!, $resultCode: String_comparison_exp) {
  checks_results(
    where: {
      check: {name: {_eq: $checkName}},
      team: {name: {_eq: $teamName}},
      result_code: $resultCode
    },
    limit: 1000,
    order_by: {check_time: desc}
  ) {
    id
    check_time
    result_code
    participant(path: "feedback")
    staff(path: "feedback")
  }
}
`;

  onMount(async () => {
    Gql.subscribeSimple<{ checks_results: CheckResultListItem[] }>(
      listQuery,
      (data) => {
        checkResultList = data.checks_results;
        if (followLatest) {
          console.debug('auto updated!');
          // automatically set the most recent result as selected
          selectedId = checkResultList[0]?.id;
        }
      },
      {
        variables: { teamName, checkName, resultCode: resultCodes.length ? { _in: resultCodes } : {} },
        role: EventRole.EventAdmin,
      },
    );

    possibleResultCodes = await getPossibleResultCodes();
  });

  type CheckResult = {
    check_time: string;
    result_code: string;
    participant: string;
    staff: string;
    check: {
      args: string;
      modified: string;
      name: string;
      script: string;
      type: string;
    };
    data: {
      [key: string]: unknown;
      exec?: {
        args: string[];
        cmd: string;
        end_time: string;
        errors: string[];
        post_delay_time: string;
        start_time: string;
        stderr: string;
        stdout: string;
      };
    };
    target: string;
    team: {
      competition_id: number;
      long_name: string;
      name: string;
    };
  };

  const checkDetailQuery = `query CheckDetailQuery($id: uuid!) {
  checks_results_by_pk(id: $id) {
    check_time
    result_code
    participant
    staff
    check {
      args
      modified
      name
      script
      type
    }
    data
    target
    team {
      competition_id
      long_name
      name
    }
  }
}`;

  async function getCheckDetail(checkId: string) {
    const response = await Gql.query<{ checks_results_by_pk: CheckResult }>(checkDetailQuery, {
      variables: { id: checkId },
    });
    console.log('loaded check result', response.checks_results_by_pk);
    return response.checks_results_by_pk;
  }

  function toggleResultCode(code: string) {
    if (resultCodes.includes(code)) {
      resultCodes = resultCodes.filter((c) => c !== code);
    } else {
      resultCodes = [...resultCodes, code];
    }
  }

  function filterOnResultCode<T extends { result_code: string }>(items: T[], codes: string[]): T[] {
    // local filter so we can maintain the same subscription
    // we probably never care about something older than 1000 results ago anyway
    if (!resultCodes.length) return items;
    return items.filter((item) => resultCodes.includes(item.result_code));
  }
</script>

<div class="row">
  <div class="col-8 d-sticky top-0">
    <LabeledContainer label="Controls">
      <div class="d-flex">
        <Input
          type="switch"
          bind:checked={followLatest}
          class="clickable d-inline-block"
          label="Follow latest result"
        />
        <div class="d-inline-block ms-auto">
          {#each possibleResultCodes as code}
            <button on:click={() => toggleResultCode(code)}>
              <Badge class="m-2" color={resultCodes.includes(code) ? 'primary' : 'secondary'}>{code}</Badge>
            </button>
          {/each}
        </div>
      </div>
    </LabeledContainer>

    {#if selectedId}
      {#await getCheckDetail(selectedId)}
        loading...
      {:then result}
        <LabeledContainer collapsable label="info">
          <div class="row text-white table pt-2">
            <!-- THEAD -->
            <div class="col-3">Result Code: {result.result_code}</div>
            <div class="col-5">Check Time: {result.check_time}</div>
            <div class="col-4">Target: {result.target}</div>
            <!--  <h4 class="col-5 d-inline-block">Feedback</h4>-->
            <!--  <h4 class="col-5 d-inline-block">Staff Feedback</h4>-->
          </div>
        </LabeledContainer>
        <LabeledContainer collapsable label="participant">
          <Prism language="json" smallCodeWindow={true} code={JSON.stringify(result.participant, null, 2)} />
        </LabeledContainer>
        <LabeledContainer collapsable label="staff">
          <Prism language="json" smallCodeWindow={true} code={JSON.stringify(result.staff, null, 2)} />
        </LabeledContainer>
        {#if result.data.exec?.stderr?.length}
          <LabeledContainer collapsable label="stderr">
            <pre>{result.data.exec.stderr}</pre>
          </LabeledContainer>
        {/if}
        {#if result.data.exec?.stdout?.length}
          <LabeledContainer collapsable label="stdout">
            <pre>{result.data.exec.stdout}</pre>
          </LabeledContainer>
        {/if}
        <LabeledContainer collapsable label="data">
          <Prism language="json" smallCodeWindow={true} code={JSON.stringify(result.data, null, 2)} />
        </LabeledContainer>
      {/await}
    {/if}
  </div>
  <div class="col-4 overflow-scroll" style="max-height: 90vh">
    <LabeledContainer collapsable label="Check List">
      <div class="container-fluid">
        <!--        <div class="row text-white pt-2">-->
        <!--          &lt;!&ndash; THEAD &ndash;&gt;-->
        <!--          <span class="col">Result Code</span>-->
        <!--          <span class="col">Check Time</span>-->
        <!--          <span class="col">Feedback</span>-->
        <!--          <span class="col">Staff Feedback</span>-->
        <!--        </div>-->
        {#each filterOnResultCode(checkResultList, resultCodes) as result}
          <button class="row w-100 text-white hover text-decoration-none p-1" on:click={() => (selectedId = result.id)}>
            <div class="col-3">result: <Badge>{result.result_code}</Badge></div>
            <div class="col-9">{result.check_time}</div>
            <div class="col-12 truncate">
              {result.participant}
            </div>
            <div class="col-12 truncate">
              {result.staff}
            </div>
          </button>
        {/each}
      </div>
    </LabeledContainer>
  </div>
</div>
